/* Simple Assembler Lister */

bool ListASM(FILE* F1, int *IP)
{
  bool running=true;
  int operand;
  int IR;

  //Fetch Instruction
  IR=Memory[*IP];
  *IP=*IP+1;
  if (IR==_movAxVar) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"\tMOV\tAX, [%04x]\n",operand);
  } else if (IR==_movVarAx) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"\tMOV\t[%04x], AX\n",operand);
  } else if (IR==_movAxImm) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"\tMOV\tAX, %d\n",operand);
  } else if (IR==_movAxBx) {
    fprintf(F1,"\tMOV\tAX, BX\n");
  } else if (IR==_movBxAx) {
    fprintf(F1,"\tMOV\tBX, AX\n");
  } else if (IR==_pushAx) {
    fprintf(F1,"\tPUSH\tAX\n");
  } else if (IR==_popAx) {
    fprintf(F1,"\tPOP\tAX\n");
  } else if (IR==_popBx) {
    fprintf(F1,"\tPOP\tBX\n");
  } else if (IR==_addBx) {
    fprintf(F1,"\tADD\tBX\n");
  } else if (IR==_subBx) {
    fprintf(F1,"\tSUB\tAX, BX\n");
  } else if (IR==_mulBx) {
    fprintf(F1,"\tMUL\tBX\n");
  } else if (IR==_divBx) {
    fprintf(F1,"\tDIV\tBX\n");
  } else if (IR==_jmp) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"\tJMP\t%04x\n",operand);
  } else if (IR==_jz) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"\tJZ\t%04x\n",operand);
  } else if (IR==_orAxAx) {
    fprintf(F1,"\tOR\tAX, AX\n");
  } else if (IR==_xorAxAx) {
    fprintf(F1,"\tXOR\tAX, AX\n");
  } else if (IR==_cmpBx) {
    fprintf(F1,"\tCMP\tAX, BX\n");
  } else if (IR==_setEq) {
    fprintf(F1,"\tSETEq\tAX\n");
  } else if (IR==_setNE) {
    fprintf(F1,"\tSETNE\tAX\n");
  } else if (IR==_setLT) {
    fprintf(F1,"\tSETLT\tAX\n");
  } else if (IR==_setLE) {
    fprintf(F1,"\tSETLE\tAX\n");
  } else if (IR==_setGT) {
    fprintf(F1,"\tSETGT\tAX\n");
  } else if (IR==_setGE) {
    fprintf(F1,"\tSETGE\tAX\n");
  } else if (IR==_wrtAx) {
    fprintf(F1,"\tWRT\tAX\n");
  } else if (IR==_wrtLn) {
    fprintf(F1,"\tWRTLN\t\n");
  } else if (IR==_rdAx) {
    fprintf(F1,"\tREAD\t\n");
  } else if (IR==_halt) {
    fprintf(F1,"\tHALT\t\n");
    running=false;
  } else {
    // Error
    fprintf(F1,"Simple Assembler Error: Unknown Command %d\n",IR);
    exit(1);
  }
  return running;
}

void SimpleASM(char *FileName)
{
  int IP=0;
  FILE* F1=fopen(FileName,"w");
  fprintf(F1,"Simple Assembler:\n");
  do {
    fprintf(F1,"%04x",IP);
  }  while (ListASM(F1,&IP));
  fclose(F1);
}
