/* Simple Compiler */

/* Language Structure */
// Factor         -> Indentifier
//                -> Integer
//                -> ( BoolExpression )
// Term           -> Factor
//                -> Factor * Factor+
//                -> Factor / Factor+
// Expression     -> Term
//                -> + Term
//                -> - Term
//                -> Term + Term+
//                -> Term - Term+
// BoolExpression -> Expressiom
//                -> Expression = Expression
//                -> Expression <> Expression
//                -> Expression < Expression
//                -> Expression <= Expression
//                -> Expression > Expression
//                -> Expression >= Expression
// Statement      -> Begin
//                -> While
//                -> If
//                -> Write
//                -> Read
//                -> Assignment
// Begin          -> Statement    \\ This is where a statement separater (";") should added!
//                -> End
// While          -> BoolExpression Statement
// If             -> BoolExpression then Statement
//                -> BoolExpression then Statement "else" Statement
// Write          -> BoolExpression , BoolExpression+
// Read           -> Input
// Assignment     -> Indentifier = BoolExpression


/* Interpreter Constants */
const int _movAxVar=  1;
const int _movAxImm=  2;
const int _movAxBx =  3;
const int _movBxAx =  4;
const int _movVarAx=  5;
const int _pushAx  =  6;
const int _pushBx  =  7;
const int _pushFx  =  8;
const int _popAx   =  9;
const int _popBx   = 10;
const int _popFx   = 11;
const int _addBx   = 12;
const int _subBx   = 13;
const int _mulBx   = 14;
const int _divBx   = 15;
const int _setEq   = 16;
const int _setNE   = 17;
const int _setLT   = 18;
const int _setLE   = 19;
const int _setGT   = 20;
const int _setGE   = 21;
const int _jmp     = 22;
const int _jz      = 23;
const int _orAxAx  = 24;
const int _xorAxAx = 25;
const int _cmpBx   = 26;
const int _wrtAx   = 27;
const int _wrtLn   = 28;
const int _rdAx    = 29;
const int _halt    =255;

/* Tokeniser Keywords and Constants */
const int _ident   = 1;
const int _integer = 2;
const int _begin   = 3;
const int _if      = 4;
const int _then    = 5;
const int _else    = 6;
const int _while   = 7;
const int _end     = 8;
const int _writeAx = 9;
const int _readAx  =10;
const int _lparent =21;
const int _rparent =22;
const int _plus    =23;
const int _minus   =24;
const int _mul     =25;
const int _div     =26;
const int _comma   =27;
const int _eq      =28;
const int _ne      =29;
const int _lt      =30;
const int _le      =31;
const int _gt      =32;
const int _ge      =33;
const int _unknown =34;

/* CPU MODEL */
// 16 bit data bus and address bus
// int Ax;             // Primary registeer
// int Bx;             // Secondary register
// int Fx;             // Flag register
int DP=49152;          // Moves up (DP=DP+1)
int SP=65504;          // Moves down (SP=SP-1)
int Memory[65536];
