/* Simple OpCode Lister */

bool ListOpCode(FILE* F1, int *IP)
{
  bool running=true;
  int operand;
  int IR;

  //Fetch Instruction
  IR=Memory[*IP];
  *IP=*IP+1;
  if (IR==_movAxVar) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"movAxVar %5d\n",operand);
  } else if (IR==_movVarAx) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"movVarAx %5d\n",operand);
  } else if (IR==_movAxImm) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"movAxImm %5d\n",operand);
  } else if (IR==_movAxBx) {
    fprintf(F1,"movAxBx  %5d\n",0);
  } else if (IR==_movBxAx) {
    fprintf(F1,"movBxAx  %5d\n",0);
  } else if (IR==_pushAx) {
    fprintf(F1,"pushAx   %5d\n",0);
  } else if (IR==_pushBx) {
    fprintf(F1,"pushBx   %5d\n",0);
  } else if (IR==_pushFx) {
    fprintf(F1,"pushFx   %5d\n",0);
  } else if (IR==_popAx) {
    fprintf(F1,"popAx    %5d\n",0);
  } else if (IR==_popBx) {
    fprintf(F1,"popBx    %5d\n",0);
  } else if (IR==_popFx) {
    fprintf(F1,"popFx    %5d\n",0);
  } else if (IR==_addBx) {
    fprintf(F1,"addBx    %5d\n",0);
  } else if (IR==_subBx) {
    fprintf(F1,"subBx    %5d\n",0);
  } else if (IR==_mulBx) {
    fprintf(F1,"mulBx    %5d\n",0);
  } else if (IR==_divBx) {
    fprintf(F1,"divBx    %5d\n",0);
  } else if (IR==_jmp) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"jmp      %5d\n",operand);
  } else if (IR==_jz) {
    // Fetch Address
    operand=Memory[*IP];
    *IP=*IP+1;
    fprintf(F1,"jz       %5d\n",operand);
  } else if (IR==_orAxAx) {
    fprintf(F1,"orAxAx   %5d\n",0);
  } else if (IR==_xorAxAx) {
    fprintf(F1,"xorAxAx  %5d\n",0);
  } else if (IR==_cmpBx) {
    fprintf(F1,"cmpBx    %5d\n",0);
  } else if (IR==_setEq) {
    fprintf(F1,"setEq    %5d\n",0);
  } else if (IR==_setNE) {
    fprintf(F1,"setNE    %5d\n",0);
  } else if (IR==_setLT) {
    fprintf(F1,"setLT    %5d\n",0);
  } else if (IR==_setLE) {
    fprintf(F1,"setLE    %5d\n",0);
  } else if (IR==_setGT) {
    fprintf(F1,"setGT    %5d\n",0);
  } else if (IR==_setGE) {
    fprintf(F1,"setGE    %5d\n",0);
  } else if (IR==_wrtAx) {
    fprintf(F1,"wrtAx    %5d\n",0);
  } else if (IR==_wrtLn) {
    fprintf(F1,"wrtLn    %5d\n",0);
  } else if (IR==_rdAx) {
    fprintf(F1,"rdAx     %5d\n",0);
  } else if (IR==_halt) {
    fprintf(F1,"halt     %5d\n",0);
    running=false;
  } else {
    // Error
    fprintf(F1,"Simple OpCode Error: Unknown Command %d\n",IR);
    exit(1);
  }
  return running;
}

void SimpleOpCode(char *FileName)
{
  int IP=0;
  FILE* F1=fopen(FileName,"w");
  fprintf(F1,"Simple OpCode:\n");
  do {
    fprintf(F1,"%5d: ",IP);
  } while (ListOpCode(F1,&IP));
  fclose(F1);
}
